routes/web.php
<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Route;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return redirect()->route('login');
})->name('/');




// Guest Users
Route::middleware(['guest', 'PreventBackHistory'])->group(function () {
    Route::get('login', [App\Http\Controllers\Admin\AuthController::class, 'showLogin'])->name('login');
    Route::post('login', [App\Http\Controllers\Admin\AuthController::class, 'login'])->name('signin');
    Route::get('register', [App\Http\Controllers\Admin\AuthController::class, 'showRegister'])->name('register');
    Route::post('register', [App\Http\Controllers\Admin\AuthController::class, 'register'])->name('signup');
});




// Authenticated users
Route::middleware(['auth', 'PreventBackHistory', 'confirm-login-type'])->group(function () {

    // Auth Routes
    Route::get('home', fn() => redirect()->route('dashboard'))->name('home');
    Route::get('show-login-types', [App\Http\Controllers\Admin\AuthController::class, 'showLoginTypes'])->name('show-login-types');
    Route::get('confirm-login-type/{type}', [App\Http\Controllers\Admin\AuthController::class, 'confirmLoginType'])->name('confirm-login-type');
    Route::get('dashboard', [App\Http\Controllers\Admin\DashboardController::class, 'index'])->name('dashboard');
    Route::post('logout', [App\Http\Controllers\Admin\AuthController::class, 'Logout'])->name('logout');
    Route::get('change-theme-mode', [App\Http\Controllers\Admin\DashboardController::class, 'changeThemeMode'])->name('change-theme-mode');
    Route::get('show-change-password', [App\Http\Controllers\Admin\AuthController::class, 'showChangePassword'])->name('show-change-password');
    Route::post('change-password', [App\Http\Controllers\Admin\AuthController::class, 'changePassword'])->name('change-password');



    // Masters
    Route::resource('fiscal_years', App\Http\Controllers\Admin\Masters\FiscalYearController::class);
    Route::resource('departments', App\Http\Controllers\Admin\Masters\DepartmentController::class);

    Route::resource('diary', App\Http\Controllers\DiaryController::class);



    // Clerk Routes
    Route::resource('audit', App\Http\Controllers\Admin\ClerkAuditController::class);



    // MCA / DY MCA Routes
    Route::get('audit/status/{status}', [App\Http\Controllers\Admin\MCAAuditController::class, 'statusWiseAuditList'])->name('audit-list.status');
    Route::put('audit/status_change/{audit}', [App\Http\Controllers\Admin\MCAAuditController::class, 'auditStatusChange'])->name('audit.status-change');
    Route::get('assign-auditor', [App\Http\Controllers\Admin\MCAAuditController::class, 'assignAudiorList'])->name('assign-auditor');
    Route::get('audit/{audit}/get-auditors', [App\Http\Controllers\Admin\MCAAuditController::class, 'getAuditors'])->name('audit.get-auditors');
    Route::put('audit/{audit}/assign-auditor', [App\Http\Controllers\Admin\MCAAuditController::class, 'assignAuditor'])->name('audit.assign-auditor');
    Route::get('draft-review', [App\Http\Controllers\Admin\MCAAuditController::class, 'draftReview'])->name('draft-review');
    Route::get('draft-answer-details/{audit}', [App\Http\Controllers\Admin\MCAAuditController::class, 'draftAnswerDetails'])->name('draft-answer-details');
    Route::put('draft-approve-answers/{audit}', [App\Http\Controllers\Admin\MCAAuditController::class, 'draftApproveAnswer'])->name('draft-approve-answers');
    Route::get('final-report', [App\Http\Controllers\Admin\MCAAuditController::class, 'finalReport'])->name('final-report');



    // Auditor Routes
    Route::get('assigned-audit', [App\Http\Controllers\Admin\AuditorAuditController::class, 'assignedAuditList'])->name('assigned-audit.index');
    Route::get('audit-info', [App\Http\Controllers\Admin\AuditorAuditController::class, 'getAuditInfo'])->name('get-audit-info');
    Route::post('send-letter', [App\Http\Controllers\Admin\AuditorAuditController::class, 'sendLetter'])->name('send-letter');
    Route::get('objection-create', [App\Http\Controllers\Admin\AuditorAuditController::class, 'createObjection'])->name('objection.create');
    Route::post('objection-store', [App\Http\Controllers\Admin\AuditorAuditController::class, 'storeObjection'])->name('objection.store');
    Route::get('answered-questions', [App\Http\Controllers\Admin\AuditorAuditController::class, 'answeredQuestions'])->name('answered-questions');
    Route::get('answer-details/{audit}', [App\Http\Controllers\Admin\AuditorAuditController::class, 'answerDetails'])->name('answer-details');
    Route::put('approve-answers/{audit}', [App\Http\Controllers\Admin\AuditorAuditController::class, 'approveAnswer'])->name('approve-answers');



    // Department Routes
    Route::get('department_letter', [App\Http\Controllers\Admin\DepartmentAuditController::class, 'index'])->name('department-letter.index');
    Route::get('compliance-create', [App\Http\Controllers\Admin\DepartmentAuditController::class, 'createCompliance'])->name('compliance.create');
    Route::get('compliance-info/{audit}', [App\Http\Controllers\Admin\DepartmentAuditController::class, 'complianceInfo'])->name('compliance.info');
    Route::put('compliance-update/{audit}', [App\Http\Controllers\Admin\DepartmentAuditController::class, 'updateCompliance'])->name('compliance.update');

    // Account Department Routes
    Route::resource('receipts', App\Http\Controllers\Admin\AccountReceiptController::class);
    Route::resource('payment-receipts', App\Http\Controllers\Admin\AccountPaymentReceiptController::class);

    // RECEIPT APPROVE/REJECT Routes
    Route::get('receipts/status/pending-list', [App\Http\Controllers\Admin\AccountReceiptController::class, 'pendingReceipts'])->name('receipts.pending-list');
    Route::get('receipts/status/approved-list', [App\Http\Controllers\Admin\AccountReceiptController::class, 'approvedReceipts'])->name('receipts.approved-list');
    Route::get('receipts/status/rejected-list', [App\Http\Controllers\Admin\AccountReceiptController::class, 'rejectedReceipts'])->name('receipts.rejected-list');
    Route::get('receipts/details/{receipt}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'receiptDetails'])->name('receipts.details');
    Route::get('receipt-info/{receipt}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'receiptInfo'])->name('receipts.info');
    Route::put('approve-receipts/{receipt}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'approveReceipts'])->name('approve-receipts');

    // PAYMENT RECEIPT APPROVE/REJECT Routes
    Route::get('payment-receipts/status/pending-list', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'pendingReceipts'])->name('payment-receipts.pending-list');
    Route::get('payment-receipts/status/approved-list', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'approvedReceipts'])->name('payment-receipts.approved-list');
    Route::get('payment-receipts/status/rejected-list', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'rejectedReceipts'])->name('payment-receipts.rejected-list');
    Route::get('payment-receipts/details/{payment_receipt}', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'receiptDetails'])->name('payment-receipts.details');
    Route::get('payment-receipt-info/{payment_receipt}', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'receiptInfo'])->name('payment-receipts.info');
    Route::put('approve-payment-receipts/{payment_receipt}', [App\Http\Controllers\Admin\AccountPaymentReceiptController::class, 'approveReceipts'])->name('approve-payment-receipts');

    // // DY MCA ROUTES
    // Route::get('dy-mca-receipt-info/{receipt}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'receiptInfo'] )->name('receipts.info');
    // Route::put('dy-mca-approve-receipts/{audit}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'approveReceipts'] )->name('approve-receipts');

    // // MCA ROUTES
    // Route::get('mca-receipt-info/{receipt}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'receiptInfo'] )->name('receipts.info');
    // Route::put('mca-approve-receipts/{audit}', [App\Http\Controllers\Admin\AccountReceiptController::class, 'approveReceipts'] )->name('approve-receipts');



    // Users Roles n Permissions
    Route::resource('users', App\Http\Controllers\Admin\UserController::class);
    Route::get('users/{user}/toggle', [App\Http\Controllers\Admin\UserController::class, 'toggle'])->name('users.toggle');
    Route::get('users/{user}/retire', [App\Http\Controllers\Admin\UserController::class, 'retire'])->name('users.retire');
    Route::put('users/{user}/change-password', [App\Http\Controllers\Admin\UserController::class, 'changePassword'])->name('users.change-password');
    Route::get('users/{user}/get-role', [App\Http\Controllers\Admin\UserController::class, 'getRole'])->name('users.get-role');
    Route::put('users/{user}/assign-role', [App\Http\Controllers\Admin\UserController::class, 'assignRole'])->name('users.assign-role');
    Route::resource('roles', App\Http\Controllers\Admin\RoleController::class);
});




Route::get('/php', function (Request $request) {
    if (!auth()->check())
        return 'Unauthorized request';

    Artisan::call($request->artisan);
    return dd(Artisan::output());
});

app/Http/Controllers/Admin/Masters/DepartmentController.php
<?php

namespace App\Http\Controllers\Admin\Masters;

use App\Http\Controllers\Admin\Controller;
use App\Http\Requests\Admin\Masters\StoreDepartmentRequest;
use App\Http\Requests\Admin\Masters\UpdateDepartmentRequest;
use App\Models\Department;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;


class DepartmentController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $departments = Department::latest()->get();

        return view('admin.masters.departments')->with(['departments'=> $departments]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreDepartmentRequest $request)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            Department::create( Arr::only( $input, Department::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Department created successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'creating', 'Department');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Department $department)
    {
        if ($department)
        {
            $response = [
                'result' => 1,
                'department' => $department,
            ];
        }
        else
        {
            $response = ['result' => 0];
        }
        return $response;
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateDepartmentRequest $request, Department $department)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            $department->update( Arr::only( $input, Department::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Department updated successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Department');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Department $department)
    {
        try
        {
            DB::beginTransaction();
            $department->delete();
            DB::commit();

            return response()->json(['success'=> 'Department deleted successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'deleting', 'Department');
        }
    }
}

app/Http/Controllers/Admin/Masters/FiscalYearController.php
<?php

namespace App\Http\Controllers\Admin\Masters;

use App\Http\Controllers\Admin\Controller;
use App\Http\Requests\Admin\Masters\StoreFiscalYearRequest;
use App\Http\Requests\Admin\Masters\UpdateFiscalYearRequest;
use App\Models\FiscalYear;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;


class FiscalYearController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $fiscal_years = FiscalYear::latest()->get();

        return view('admin.masters.fiscal_years')->with(['fiscal_years'=> $fiscal_years]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreFiscalYearRequest $request)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            FiscalYear::create( Arr::only( $input, FiscalYear::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Financial Year created successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'creating', 'Financial Year');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(FiscalYear $fiscal_year)
    {
        if ($fiscal_year)
        {
            $response = [
                'result' => 1,
                'fiscal_year' => $fiscal_year,
            ];
        }
        else
        {
            $response = ['result' => 0];
        }
        return $response;
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateFiscalYearRequest $request, FiscalYear $fiscal_year)
    {
        try
        {
            DB::beginTransaction();
            $input = $request->validated();
            $fiscal_year->update( Arr::only( $input, FiscalYear::getFillables() ) );
            DB::commit();

            return response()->json(['success'=> 'Financial Year updated successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Financial Year');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(FiscalYear $fiscal_year)
    {
        try
        {
            DB::beginTransaction();
            $fiscal_year->delete();
            DB::commit();

            return response()->json(['success'=> 'Financial Year deleted successfully!']);
        }
        catch(\Exception $e)
        {
            return $this->respondWithAjax($e, 'deleting', 'Financial Year');
        }
    }
}

resources/views/admin/masters/departments.blade.php
<x-admin.layout>
    <x-slot name="title">Departments</x-slot>
    <x-slot name="heading">Departments</x-slot>
    {{-- <x-slot name="subheading">Test</x-slot> --}}


        <!-- Add Form -->
        <div class="row" id="addContainer" style="display:none;">
            <div class="col-sm-12">
                <div class="card">
                    <form class="theme-form" name="addForm" id="addForm" enctype="multipart/form-data">
                        @csrf

                        <div class="card-header">
                            <h4 class="card-title">Add Department</h4>
                        </div>
                        <div class="card-body">
                            <div class="mb-3 row">
                                <div class="col-md-4">
                                    <label class="col-form-label" for="name">Department Name <span class="text-danger">*</span></label>
                                    <input class="form-control" id="name" name="name" type="text" placeholder="Enter Department Name">
                                    <span class="text-danger is-invalid name_err"></span>
                                </div>
                                <div class="col-md-4">
                                    <label class="col-form-label" for="initial">Is Audit Dept. ?<span class="text-danger">*</span></label>
                                    <select name="is_audit" id="is_audit" class="form-control">
                                        <option value="0">No</option>
                                        <option value="1">Yes</option>
                                    </select>
                                    <span class="text-danger is-invalid is_audit_err"></span>
                                </div>
                            </div>

                        </div>
                        <div class="card-footer">
                            <button type="submit" class="btn btn-primary" id="addSubmit">Submit</button>
                            <button type="reset" class="btn btn-warning">Reset</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>



        {{-- Edit Form --}}
        <div class="row" id="editContainer" style="display:none;">
            <div class="col">
                <form class="form-horizontal form-bordered" method="post" id="editForm">
                    @csrf
                    <div class="card">
                        <div class="card-header">
                            <h4 class="card-title">Edit Department</h4>
                        </div>
                        <div class="card-body py-2">
                            <input type="hidden" id="edit_model_id" name="edit_model_id" value="">
                            <div class="mb-3 row">
                                <div class="col-md-4">
                                    <label class="col-form-label" for="name">Department Name <span class="text-danger">*</span></label>
                                    <input class="form-control" id="name" name="name" type="text" placeholder="Enter Department Name">
                                    <span class="text-danger is-invalid name_err"></span>
                                </div>
                                <div class="col-md-4">
                                    <label class="col-form-label" for="initial">Is Audit Dept. ?<span class="text-danger">*</span></label>
                                    <select name="is_audit" id="is_audit" class="form-control">
                                        <option value="0">No</option>
                                        <option value="1">Yes</option>
                                    </select>
                                    <span class="text-danger is-invalid is_audit_err"></span>
                                </div>
                            </div>

                        </div>
                        <div class="card-footer">
                            <button class="btn btn-primary" id="editSubmit">Submit</button>
                            <button type="reset" class="btn btn-warning">Reset</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>


        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <div class="row">
                            <div class="col-sm-6">
                                <div class="">
                                    <button id="addToTable" class="btn btn-primary">Add <i class="fa fa-plus"></i></button>
                                    <button id="btnCancel" class="btn btn-danger" style="display:none;">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="table-responsive">
                            <table id="buttons-datatables" class="table table-bordered nowrap align-middle" style="width:100%">
                                <thead>
                                    <tr>
                                        <th>Sr No</th>
                                        <th>Name</th>
                                        <th>Is Audit Dept.</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach ($departments as $department)
                                        <tr>
                                            <td>{{ $loop->iteration }}</td>
                                            <td>{{ $department->name }}</td>
                                            <td>{{ $department->is_audit == 1 ? 'YES' : 'NO' }}</td>
                                            <td>
                                                <button class="edit-element btn text-secondary px-2 py-1" title="Edit department" data-id="{{ $department->id }}"><i data-feather="edit"></i></button>
                                                <button class="btn text-danger rem-element px-2 py-1" title="Delete department" data-id="{{ $department->id }}"><i data-feather="trash-2"></i> </button>
                                            </td>
                                        </tr>
                                    @endforeach
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>




</x-admin.layout>


{{-- Add --}}
<script>
    $("#addForm").submit(function(e) {
        e.preventDefault();
        $("#addSubmit").prop('disabled', true);

        var formdata = new FormData(this);
        $.ajax({
            url: '{{ route('departments.store') }}',
            type: 'POST',
            data: formdata,
            contentType: false,
            processData: false,
            success: function(data)
            {
                $("#addSubmit").prop('disabled', false);
                if (!data.error2)
                    swal("Successful!", data.success, "success")
                        .then((action) => {
                            window.location.href = '{{ route('departments.index') }}';
                        });
                else
                    swal("Error!", data.error2, "error");
            },
            statusCode: {
                422: function(responseObject, textStatus, jqXHR) {
                    $("#addSubmit").prop('disabled', false);
                    resetErrors();
                    printErrMsg(responseObject.responseJSON.errors);
                },
                500: function(responseObject, textStatus, errorThrown) {
                    $("#addSubmit").prop('disabled', false);
                    swal("Error occured!", "Something went wrong please try again", "error");
                }
            }
        });

    });
</script>


<!-- Edit -->
<script>
    $("#buttons-datatables").on("click", ".edit-element", function(e) {
        e.preventDefault();
        var model_id = $(this).attr("data-id");
        var url = "{{ route('departments.edit', ":model_id") }}";

        $.ajax({
            url: url.replace(':model_id', model_id),
            type: 'GET',
            data: {
                '_token': "{{ csrf_token() }}"
            },
            success: function(data, textStatus, jqXHR) {
                editFormBehaviour();
                if (!data.error)
                {
                    $("#editForm input[name='edit_model_id']").val(data.department.id);
                    $("#editForm input[name='name']").val(data.department.name);
                    $("#editForm select[name='is_audit']").val(data.department.is_audit);
                }
                else
                {
                    alert(data.error);
                }
            },
            error: function(error, jqXHR, textStatus, errorThrown) {
                alert("Some thing went wrong");
            },
        });
    });
</script>


<!-- Update -->
<script>
    $(document).ready(function() {
        $("#editForm").submit(function(e) {
            e.preventDefault();
            $("#editSubmit").prop('disabled', true);
            var formdata = new FormData(this);
            formdata.append('_method', 'PUT');
            var model_id = $('#edit_model_id').val();
            var url = "{{ route('departments.update', ":model_id") }}";
            //
            $.ajax({
                url: url.replace(':model_id', model_id),
                type: 'POST',
                data: formdata,
                contentType: false,
                processData: false,
                success: function(data)
                {
                    $("#editSubmit").prop('disabled', false);
                    if (!data.error2)
                        swal("Successful!", data.success, "success")
                            .then((action) => {
                                window.location.href = '{{ route('departments.index') }}';
                            });
                    else
                        swal("Error!", data.error2, "error");
                },
                statusCode: {
                    422: function(responseObject, textStatus, jqXHR) {
                        $("#editSubmit").prop('disabled', false);
                        resetErrors();
                        printErrMsg(responseObject.responseJSON.errors);
                    },
                    500: function(responseObject, textStatus, errorThrown) {
                        $("#editSubmit").prop('disabled', false);
                        swal("Error occured!", "Something went wrong please try again", "error");
                    }
                }
            });

        });
    });
</script>


<!-- Delete -->
<script>
    $("#buttons-datatables").on("click", ".rem-element", function(e) {
        e.preventDefault();
        swal({
            title: "Are you sure to delete this department?",
            // text: "Make sure if you have filled Vendor details before proceeding further",
            icon: "info",
            buttons: ["Cancel", "Confirm"]
        })
        .then((justTransfer) =>
        {
            if (justTransfer)
            {
                var model_id = $(this).attr("data-id");
                var url = "{{ route('departments.destroy', ":model_id") }}";

                $.ajax({
                    url: url.replace(':model_id', model_id),
                    type: 'POST',
                    data: {
                        '_method': "DELETE",
                        '_token': "{{ csrf_token() }}"
                    },
                    success: function(data, textStatus, jqXHR) {
                        if (!data.error && !data.error2) {
                            swal("Success!", data.success, "success")
                                .then((action) => {
                                    window.location.reload();
                                });
                        } else {
                            if (data.error) {
                                swal("Error!", data.error, "error");
                            } else {
                                swal("Error!", data.error2, "error");
                            }
                        }
                    },
                    error: function(error, jqXHR, textStatus, errorThrown) {
                        swal("Error!", "Something went wrong", "error");
                    },
                });
            }
        });
    });
</script>